/*
 *Copyright (C) 2016 Kipp Cannon <kipp.cannon@ligo.org>, Theresa Chmiel, Madeline Wade
 *    
 *Permission is hereby granted, free of charge, to any person obtaining a
 *copy of this software and associated documentation files (the
 *"Software"), to deal in the Software without restriction, including
 *without limitation the rights to use, copy, modify, merge, publish,
 *distribute, sublicense, and/or sell copies of the Software, and to
 *permit persons to whom the Software is furnished to do so, subject to
 *the following conditions:
 *           
 *The above copyright notice and this permission notice shall be included
 *in all copies or substantial portions of the Software.
 *              
 *THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
 *OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 *MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
 *IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
 *CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
 *TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
 *SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *                      
 *Alternatively, the contents of this file may be used under the GNU
 *Lesser General Public License Version 2.1 (the "LGPL"), in which case
 *the following provisions apply instead of the ones mentioned above:
 *                          
 *This library is free software; you can redistribute it and/or modify it
 *under the terms of the GNU Library General Public License as published
 *by the Free Software Foundation; either version 2 of the License, or (at
 *your option) any later version.
 *                               
 *This library is distributed in the hope that it will be useful, but
 *WITHOUT ANY WARRANTY; without even the implied warranty of
 *MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *Library General Public License for more details.
 *                                    
 *You should have received a copy of the GNU Library General Public
 *License along with this library; if not, write to the Free Software
 *Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301,
 *USA.
 */

#ifndef __GST_LAL_FCC_UPDATE_H__
#define __GST_LAL_FCC_UPDATE_H__


#include <glib.h>
#include <gst/gst.h>
#include <gst/base/gstbasetransform.h>
#include <gsl/gsl_matrix.h>

#include <gst/audio/audio.h>
#include <gstlal/gstaudioadapter.h>
#include <complex.h>
#include <fftw3.h>

G_BEGIN_DECLS

#define GSTLAL_FCC_UPDATE_TYPE \
        (gstlal_fcc_update_get_type())
#define GSTLAL_FCC_UPDATE(obj) \
        (G_TYPE_CHECK_INSTANCE_CAST((obj), GSTLAL_FCC_UPDATE_TYPE, GSTLALFccUpdate))
#define GSTLAL_FCC_UPDATE_CLASS(klass) \
        (G_TYPE_CHECK_CLASS_CAST((klass), GSTLAL_FCC_UPDATE_TYPE, GSTLALFccUpdateClass))
#define GST_IS_GSTLAL_FCC_UPDATE(obj) \
        (G_TYPE_CHECK_INSTANCE_TYPE((obj), GSTLAL_FCC_UPDATE_TYPE))
#define GST_IS_GSTLAL_FCC_UPDATE_CLASS(klass) \
        (G_TYPE_CHECK_CLASS_TYPE((klass), GSTLAL_FCC_UPDATE_TYPE))



typedef struct _GSTLALFccUpdate GSTLALFccUpdate;
typedef struct _GSTLALFccUpdateClass GSTLALFccUpdateClass;



struct _GSTLALFccUpdate {
        GstBaseTransform element;
	gsl_matrix *fir_matrix;
	int index;
	double currentaverage;
	gint datarate;
	gint fccrate;
	gdouble filterduration;
	gdouble fcmodel;
	gdouble averaging_time;
};





struct _GSTLALFccUpdateClass {
        GstBaseTransformClass parent_class;
};


GType gstlal_fcc_update_get_type(void);

G_END_DECLS


#endif  /* __GST_LAL_FCC_UPDATE_H__ */








